#include <math.h>
#include "MPU9250.h"


uint8_t data[2];

float accelRange,gyroRange;

#define READ_FLAG   0x80

uint8_t accelBuf[6];

uint8_t data[2];


void MPU9250_beginAccel(uint8_t mode) {
  switch(mode) {
  case ACC_FULL_SCALE_2_G:
    accelRange = 2.0;
    break;
  case ACC_FULL_SCALE_4_G:
    accelRange = 4.0;
    break;
  case ACC_FULL_SCALE_8_G:
    accelRange = 8.0;
    break;
  case ACC_FULL_SCALE_16_G:
    accelRange = 16.0;
    break;
  default:
    return; // Return without writing invalid mode
  }

	data[0]=USER_CTRL; data[1]=(1<<4);
	Slave_Select(MPU9250_CS);
	SPI_Write(data,2);
	Slave_Deselect(MPU9250_CS);
		
	data[0]=MPU9250_ADDR_ACCELCONFIG; data[1]=mode;
	Slave_Select(MPU9250_CS);
	SPI_Write(data,2);
	Slave_Deselect(MPU9250_CS);

}

uint8_t MPU9250_accelUpdate(void) {

	data[0]=(uint8_t)(0x3B|READ_FLAG);
	Slave_Select(MPU9250_CS);
	SPI_Write(data,1);
	SPI_Receive((uint8_t*)(accelBuf),6);
	Slave_Deselect(MPU9250_CS);
	
	return 0;
}


float MPU9250_accelGet(uint8_t highIndex, uint8_t lowIndex) {
  int16_t v = ((int16_t) accelBuf[highIndex]) << 8 | accelBuf[lowIndex];
  return ((float) -v) * accelRange / (float) 0x8000; // (float) 0x8000 == 32768.0
}



float MPU9250_accelX(void) {
  return MPU9250_accelGet(1, 2);
}

float MPU9250_accelY(void) {
  return MPU9250_accelGet(3, 4);
}

float MPU9250_accelZ(void) {
  return MPU9250_accelGet(5, 6);
}

